const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const maintenance = sequelize.define(
    'maintenance',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      type: {
        type: DataTypes.ENUM,

        values: ['preventive', 'corrective'],
      },

      scheduled_at: {
        type: DataTypes.DATE,
      },

      odometer: {
        type: DataTypes.INTEGER,
      },

      cost: {
        type: DataTypes.DECIMAL,
      },

      notes: {
        type: DataTypes.TEXT,
      },

      attachments: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  maintenance.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.maintenance.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.maintenance.belongsTo(db.vehicles, {
      as: 'vehicle',
      foreignKey: {
        name: 'vehicleId',
      },
      constraints: false,
    });

    db.maintenance.belongsTo(db.agences, {
      as: 'agences',
      foreignKey: {
        name: 'agencesId',
      },
      constraints: false,
    });

    db.maintenance.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.maintenance.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return maintenance;
};
